#!/usr/local/bin/gawk -f
#
# Usage: ./pob2o.awk <POB file name>|../bin/send_order ...
#
#  POB  - K2 order
#  1    - 4
#  2    - 5 
#  3    - 8
#  4    - 3 
#  5    - 2
#  6    - 9 
#  7    - 1 
#  8    - 10
#  9    - 11
#  10   - 15
#  11   - 12
#  12   - 13
#  13   - 14
#  14   - 6 
#  15   - "0"
#  "j" - 7
#  
#  
BEGIN { FS = "|";
        command = "../bin/get_table secboard";
        while ((command | getline) > 0) {
          gsub("[ ]*$", "", $2);          # string trim left space
          pricedec[$2] = $30;             # store pricedecimals
        }
        close(command);
        command = "../bin/get_table board";
        while ((command | getline) > 0) {
          gsub("[ ]*$", "", $2);          # string trim left space
          gsub("[ ]*$", "", $3);          # string trim left space
          boards[$3] = $2;                # store boardids
        }
        close(command);
        FS = "\t"; OFS = "|";
      }

{
  if (NR > 1) {
    board = boards[$3];
    pd = pricedec["0" board $2] ;
    gsub(",", ".", $9);   # price
    gsub(",", ".", $1);   # yield
    gsub(",", ".", $14);  # trigger price
    $9  *= (10 ^ pd);
    $1  *= (10 ^ pd);
    $14 *= (10 ^ pd);
    print $4, 
          $5 == "V" ? "B" : "S", 
          $8, 
          board,
          $2, 
          $9  ? $9  : "0", 
          $1  ? $1  : "0", 
          $10 ? $10 : "0", 
          $11 ? $11 : "0", 
          $15,
          $12 ? $12 : "0", 
          $13 ? $13 : "0", 
          $14 ? $14 : "0", 
          $6  ? $6  : "0", 
          "0",
          " ";
  }
}
