/*****************************************************************************
         (c) Copyright Effice Mrnki Iroda Kft. 1999.


Ez az llomny kizrolag az Effice Kft. (2083 Solymr Toldi u. 21.) tulajdona,
kizrolag csak az Effice Kft. engedlyvel, az engedlyben meghatrozott clra
s mdon hasznlhat fel.


  Socket based interface constant definitions.
*****************************************************************************/

#ifndef __IFS_DEFS__

#include "fields.h"

#define IFS_MSG_PROTOCOL_VERSION 4

/*+ ------- tables ------------- +*/
#define IFS_T_MARKET              1
#define IFS_T_INSTR               2
#define IFS_T_SECTOR              3     
#define IFS_T_BOARD               4
#define IFS_T_SECBOARD            5
#define IFS_T_FIRM                6
#define IFS_T_USER                7
#define IFS_T_ORDER               8
#define IFS_T_TRADE               9
#define IFS_T_NEGDEAL            10
#define IFS_T_ORDERENTRY         11
#define IFS_T_MMORDER            12
#define IFS_T_AUDITEVENT         13
#define IFS_T_PRICEPARAM         14
#define IFS_T_LAST               15  /* write new code before this ! */

/*+ ------- field types -------- +*/
#define IFS_INT                 "%010d"
#define IFS_INT_LEN             11
#define IFS_DOUBLE              "%019.2f"
#define IFS_DOUBLE_LEN          20
#define IFS_FIXREAL_DOUBLE      "%019.*f"
#define IFS_IDS                 "%-12s"
#define IFS_IDS_LEN             13
#define IFS_PWD                 "%-10s"
#define IFS_PWD_LEN             11
#define IFS_CODE                "%04d"
#define IFS_CODE_LEN            5
#define IFS_CHAR                "%c"
#define IFS_CHAR_LEN            2
#define IFS_ENUM                "%02d"
#define IFS_ENUM_LEN            3
#define IFS_ORDERMETHOD         "%-32s"
#define IFS_ORDERMETHOD_LEN     33
#define IFS_BOARDID             "%-4s"
#define IFS_BOARDID_LEN         5
#define IFS_SECBOARDID          "%-24s"
#define IFS_SECBOARDID_LEN      25
#define IFS_BROKERREF           "%-40s"
#define IFS_BROKERREF_LEN       41
#define IFS_USER_MIFIDID        "%-50s"
#define IFS_USER_MIFIDID_LEN    51
#define IFS_TRADEREF            "%-30s"
#define IFS_TRADEREF_LEN		31
#define IFS_MSG                 "%-255s"
#define IFS_MSG_LEN             256
#define IFS_STR                 "%-*s"
#define IFS_NAME_LEN            31
#define IFS_SEC_CODE_LEN        21
#define IFS_SEC_NAME_LEN        41
#define IFS_SEC_REMARK_LEN      9
#define IFS_SEC_SHORTNAME_LEN   21
#define IFS_SEC_INDICATOR_LEN   11
#define IFS_FREE_TEXT_LEN       51
#define IFS_IPADDR_LEN          17
#define IFS_QUOTEBASES_LEN      21
#define IFS_CLEARINGCODE_LEN    21
#define IFS_ORDERNO_LEN         22
#define IFS_TRADENO_LEN         22
#define IFS_FIXREAL_LEN         IFS_DOUBLE_LEN + IFS_INT_LEN
#define IFS_DATETIME_LEN        IFS_INT_LEN + IFS_INT_LEN
#define IFS_DATETIME_MSEC_LEN   IFS_INT_LEN + IFS_INT_LEN + IFS_INT_LEN
#define IFS_CAPTION_LEN         41
#define IFS_PRICEPARAM_LEN		256	
#define IFS_UNSECPRODNAME_LEN   121
#define IFS_STRIKEPRICE_LEN     256
#define IFS_BARRIER_LEN         256

/*+ ------- codes for status - +*/
#define IFS_OK                   0
#define IFS_ERROR               -1
#define IFS_UNKNOWNMSG          -2
#define IFS_NOUSER              -3
#define IFS_NOLOGIN             -4
#define IFS_NOACTIVE            -5
#define IFS_INVPWD              -6
#define IFS_NOQUERYPRIV         -7
#define IFS_UNKNOWNTABLE        -8
#define IFS_NOSECBOARD          -9
#define IFS_NOOB                -10
#define IFS_NOENTRYPRIV         -11
#define IFS_NOSPACE             -12
#define IFS_UNKNOWNTRANS        -13
#define IFS_NOCONFIRMPRIV       -14
#define IFS_NOORDERENTRY        -15
#define IFS_UNKNOWNSTATUS       -16
#define IFS_NOCONFIGPRIV        -17
#define IFS_OBALREADYWATCH      -18
#define IFS_UNKNOWNSWITCH       -19
#define IFS_COMERROR            -20
#define IFS_MSGERROR            -21
#define IFS_OENOTCSTRING        -22
#define IFS_OETOOLONG           -23
#define IFS_UNCHANGESTATUS      -24
#define IFS_TRACEFILEERR        -25
#define IFS_OEDENIED            -26
#define IFS_RECONDIFFSRV        -27
#define IFS_NOMBP               -28
#define IFS_MBPALREADYWATCH     -29
#define IFS_NOLICENSE           -30
#define IFS_CLIENTLICEXCEED     -31
#define IFS_MSGPROTVERDIFF      -32
#define IFS_ALREADYCONNECT      -33
#define IFS_NOCONNECT           -34
#define IFS_NULLHANDLE          -35
#define IFS_MMONOTCSTRING       -36
#define IFS_MMOTOOLONG          -37
#define IFS_NOMMORDER           -38
#define IFS_UNCHANGEMMSTATUS    -39
 
#define IFS_NOMORE              1

#define IFS_SWITCH_ON              1
#define IFS_SWITCH_OFF             0
#define IFS_ACTION_ORDER_ADD       1
#define IFS_ACTION_ORDER_WITHDRAW  2
#define IFS_ACTION_ORDER_AMEND     3
#define IFS_ACTION_TICKUPTICKDOWN  4
#define IFS_ORDER_ACCEPTED        'A'     /*+ The order is accepted  by the PGW. +*/
#define IFS_ORDER_DENIED          'D'     /*+ The order is denied  by the order routing manager. +*/
#define IFS_ORDER_CONFIRMED       'C'     /*+ The order is confirmed by the order routing manager. +*/
#define IFS_ORDER_ENTERED         'E'     /*+ The order is successfully entered to the Trading Engine. +*/
#define IFS_ORDER_REFUSED         'R'     /*+ The order is refused by the Trading Engine.  +*/
#define IFS_ORDER_UNKNOWN         'U'     /*+ Trading Engine's answare is unexpected.  +*/
#define IFS_WITHDRAW_TODAY        -1      /*+ Today value for the orderdate of order withdraw message +*/

/*+ Buy or Sell -- BuySell +*/
#define BUY             'B'
#define SELL            'S'
#define BUY_OR_SELL     'E'

/*+ Order Boolean Operators -- OpCode +*/
#define O_AND           'A'
#define O_OR            'O'

/*+ Order Relational Operators -- PopCode +*/
#define O_GREATERTHAN_OR_EQUALTO  '>' /*+ >= +*/
#define O_LESSTHAN_OR_EQUALTO     '<' /*+ <= +*/
#define O_EQUALTO                 '=' /*+ == +*/
                           
/*+ OrderMethodSet attributum constants +*/
#define OM_FLAG_SET            '1' /*+ the attributum is set   +*/
#define OM_FLAG_UNSET          '0' /*+ the attributum is unset +*/

/*+ Types of orders -- OrderMethodSet +*/
#define OM_MARKET               0 /*+ market order      +*/
#define OM_LIMIT                1 /*+ limit order       +*/
#define OM_NEGDEAL              3 /*+ negotiated deal   +*/
#define OM_MARKET_MAKER         5 /*+ marketmaker order +*/

/*+ Miscellaneous characteristics of orders +*/
#define OM_YIELD               10 /*+ yield order                                   +*/
#define OM_HIDDEN              11 /*+ hidden quantities allowed                     +*/
#define OM_STOP                12 /*+ stop orders allowed                           +*/
#define OM_SETTLE_DATE         13 /*+ order can have a user defined settlement date +*/
#define OM_NO_TRDACC           14 /*+ order does not require a Trading Account      +*/

/*+ How to fill an order +*/
#define OM_FILL_ALL_OR_NONE    15 /*+ allowed to specify  MinFillQty == order's qty         +*/
#define OM_FILL_PART_MIN       16 /*+ allowed to specify  0 < MinFillQty < order's qty      +*/
#define OM_FILL_ZERO_MIN       17 /*+ allowed to specify  MinFillQty == 0                   +*/
#define OM_BEST_PRICE          18 /*+ market orders to match only at the best current price +*/

/*+ Order duration +*/
#define OM_GOOD_TILL_TIME      23 /*+ time orders allowed          +*/
#define OM_SESSION             24 /*+ sess. only orders allowed    +*/
#define OM_DAY                 25 /*+ day only orders allowed      +*/
#define OM_GOOD_TILL_DATE      26 /*+ multi day orders allowed     +*/
#define OM_GOOD_TILL_CANCELLED 27 /*+ order is good till cancelled +*/
#define OM_IMM_WITHDRAW        28 /*+ immediate withdraw allowed   +*/

#define __IFS_DEFS__  /*+ To stop multiple inclusions. +*/
#endif
